package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.converter.OfferConverter;
import com.nisum.offertransactionservice.converter.PEResponseToOfferTransactionResConverter;
import com.nisum.offertransactionservice.dao.OfferLookupRepo;
import com.nisum.offertransactionservice.model.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.List;

import static com.google.common.collect.Lists.newArrayList;

@Service
@PropertySource("classpath:application.properties")
public class OfferCallingPEService {
    @Autowired
    private OfferConverter offerConverter;

    @Autowired
    private OfferLookupRepo offerLookupRepo;

    @Autowired
    private PEResponseToOfferTransactionResConverter peResponseToOfferTransactionResConverter;

    @Autowired
    private RestTemplate restTemplate;

    @Value("${promotion.engine.calculate.discount.url}")
    private String promotionEngineUrl ;

    public OfferTransactionResponse getDiscountedItemList(OfferTransactionRequest offerTransactionRequest) {
        List<OfferLookup> eligibleOffer = newArrayList();
        offerLookupRepo.findAll().forEach(eligibleOffer::add);
        OfferTransactionResponse offerTransactionResponse ;
        PERequest peRequest = offerConverter.apply(offerTransactionRequest);
        peRequest.setEligibleOffers(eligibleOffer);
        ResponseEntity<PEResponse> peResponse = restTemplate.postForEntity("http://localhost:8081"+promotionEngineUrl,peRequest,PEResponse.class);
        offerTransactionResponse = peResponseToOfferTransactionResConverter.apply(peResponse.getBody());
        return offerTransactionResponse;
    }
}
