package com.nisum.offertransactionservice.converter;

import com.nisum.offertransactionservice.model.Item;
import com.nisum.offertransactionservice.model.OfferTransactionResponse;
import com.nisum.offertransactionservice.model.PERequest;
import com.nisum.offertransactionservice.model.PEResponse;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;

import java.util.ArrayList;
import java.util.List;

@RunWith(MockitoJUnitRunner.class)
public class PEResponseToOfferTransactionResConverterTest {


    @InjectMocks
    private PEResponseToOfferTransactionResConverter peResponseToOfferTransactionResConverter = new PEResponseToOfferTransactionResConverter();

    @Before
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void offerConverterTest() {
        OfferTransactionResponse offerTransactionResponse = peResponseToOfferTransactionResConverter.apply(getPeResponse());
        Assert.assertEquals(offerTransactionResponse, retOfferTransRes());
    }


    private OfferTransactionResponse retOfferTransRes() {
        OfferTransactionResponse offerTransactionResponse = new OfferTransactionResponse();
        offerTransactionResponse.setHhid("123");
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 6.05, "cmsCoupons");
        Item item2 = new Item("Thumpsup", "11", 12.32, "cmsCoupons");
        itemList.add(item1);
        itemList.add(item2);
        offerTransactionResponse.setDiscountedItemList(itemList);
        return offerTransactionResponse;
    }

    private PEResponse getPeResponse() {
        PEResponse peResponse = new PEResponse();
        peResponse.setHhid("123");
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 6.05, "cmsCoupons");
        Item item2 = new Item("Thumpsup", "11", 12.32, "cmsCoupons");
        itemList.add(item1);
        itemList.add(item2);
        peResponse.setDiscountedItemList(itemList);
        return peResponse;
    }

}
